// generated from rosidl_generator_cpp/resource/idl__traits.hpp.em
// with input from autoware_internal_debug_msgs:msg/ServiceLog.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "autoware_internal_debug_msgs/msg/service_log.hpp"


#ifndef AUTOWARE_INTERNAL_DEBUG_MSGS__MSG__DETAIL__SERVICE_LOG__TRAITS_HPP_
#define AUTOWARE_INTERNAL_DEBUG_MSGS__MSG__DETAIL__SERVICE_LOG__TRAITS_HPP_

#include <stdint.h>

#include <sstream>
#include <string>
#include <type_traits>

#include "autoware_internal_debug_msgs/msg/detail/service_log__struct.hpp"
#include "rosidl_runtime_cpp/traits.hpp"

// Include directives for member types
// Member 'stamp'
#include "builtin_interfaces/msg/detail/time__traits.hpp"

namespace autoware_internal_debug_msgs
{

namespace msg
{

inline void to_flow_style_yaml(
  const ServiceLog & msg,
  std::ostream & out)
{
  out << "{";
  // member: stamp
  {
    out << "stamp: ";
    to_flow_style_yaml(msg.stamp, out);
    out << ", ";
  }

  // member: type
  {
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << ", ";
  }

  // member: name
  {
    out << "name: ";
    rosidl_generator_traits::value_to_yaml(msg.name, out);
    out << ", ";
  }

  // member: node
  {
    out << "node: ";
    rosidl_generator_traits::value_to_yaml(msg.node, out);
    out << ", ";
  }

  // member: yaml
  {
    out << "yaml: ";
    rosidl_generator_traits::value_to_yaml(msg.yaml, out);
  }
  out << "}";
}  // NOLINT(readability/fn_size)

inline void to_block_style_yaml(
  const ServiceLog & msg,
  std::ostream & out, size_t indentation = 0)
{
  // member: stamp
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "stamp:\n";
    to_block_style_yaml(msg.stamp, out, indentation + 2);
  }

  // member: type
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "type: ";
    rosidl_generator_traits::value_to_yaml(msg.type, out);
    out << "\n";
  }

  // member: name
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "name: ";
    rosidl_generator_traits::value_to_yaml(msg.name, out);
    out << "\n";
  }

  // member: node
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "node: ";
    rosidl_generator_traits::value_to_yaml(msg.node, out);
    out << "\n";
  }

  // member: yaml
  {
    if (indentation > 0) {
      out << std::string(indentation, ' ');
    }
    out << "yaml: ";
    rosidl_generator_traits::value_to_yaml(msg.yaml, out);
    out << "\n";
  }
}  // NOLINT(readability/fn_size)

inline std::string to_yaml(const ServiceLog & msg, bool use_flow_style = false)
{
  std::ostringstream out;
  if (use_flow_style) {
    to_flow_style_yaml(msg, out);
  } else {
    to_block_style_yaml(msg, out);
  }
  return out.str();
}

}  // namespace msg

}  // namespace autoware_internal_debug_msgs

namespace rosidl_generator_traits
{

[[deprecated("use autoware_internal_debug_msgs::msg::to_block_style_yaml() instead")]]
inline void to_yaml(
  const autoware_internal_debug_msgs::msg::ServiceLog & msg,
  std::ostream & out, size_t indentation = 0)
{
  autoware_internal_debug_msgs::msg::to_block_style_yaml(msg, out, indentation);
}

[[deprecated("use autoware_internal_debug_msgs::msg::to_yaml() instead")]]
inline std::string to_yaml(const autoware_internal_debug_msgs::msg::ServiceLog & msg)
{
  return autoware_internal_debug_msgs::msg::to_yaml(msg);
}

template<>
inline const char * data_type<autoware_internal_debug_msgs::msg::ServiceLog>()
{
  return "autoware_internal_debug_msgs::msg::ServiceLog";
}

template<>
inline const char * name<autoware_internal_debug_msgs::msg::ServiceLog>()
{
  return "autoware_internal_debug_msgs/msg/ServiceLog";
}

template<>
struct has_fixed_size<autoware_internal_debug_msgs::msg::ServiceLog>
  : std::integral_constant<bool, false> {};

template<>
struct has_bounded_size<autoware_internal_debug_msgs::msg::ServiceLog>
  : std::integral_constant<bool, false> {};

template<>
struct is_message<autoware_internal_debug_msgs::msg::ServiceLog>
  : std::true_type {};

}  // namespace rosidl_generator_traits

#endif  // AUTOWARE_INTERNAL_DEBUG_MSGS__MSG__DETAIL__SERVICE_LOG__TRAITS_HPP_
